#define F_CPU 8000000UL  //    

#include <avr/io.h> //   

#include <util/delay.h> //   

#include <avr/interrupt.h> //   

//       

#define  servo_1 PB1 //   

#define  servo_2 PB2 //   

#define sistem_LED PB0 //    

//     I2C 

#define F_TWI 300000 //    TWI (   300 )
 
#define TWBR_value (((F_CPU)/(F_TWI)-16)/2) //    (  5),     255 ( )
 
#define MPU_adres  0x68 //    7  (1101000),   -  /

void TWI_init (void) { //   I2C 
 
  TWBR = TWBR_value; //   ,    
  
  TWSR = 0; //       ,   ,      (   )
  
  TWCR |=(1<<TWEN); //   TWI
  
}

void TWI_send (unsigned char data, unsigned char adr, unsigned char reset_register) { //   -        
  
  //   ""
  
  TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN); //         ,   ,     
  
  while(!(TWCR & (1<<TWINT))); // ,       
  
  //       
  
  TWDR = (MPU_adres<<1)|0; //      ,      ( )
  
  TWCR = (1<<TWINT)|(1<<TWEN); //  ,   
  
  while(!(TWCR & (1<<TWINT))); //    
  
  //      
  
  TWDR = adr; //      
  
  TWCR = (1<<TWINT)|(1<<TWEN); //  ,  
  
  while(!(TWCR & (1<<TWINT))); //    

  if(reset_register==0) { //     ,   
  
  //   
  
  TWDR = data; //     
  
  TWCR = (1<<TWINT)|(1<<TWEN); //  ,  
  
  while(!(TWCR & (1<<TWINT))); //   
  
  //   ""
  
  TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN); //  ,   "",  
  
  }
  
  else {}; // ,    
  
}
// -------------------------  -----------------------------------

 unsigned char TWI_read (unsigned char podt) { //      TWI

  unsigned char data; //      
  
  //   ""
  
  TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN); //         ,   ,     
  
  while(!(TWCR & (1<<TWINT))); // ,       
  
  //   ,   = 1
  
  TWDR = (MPU_adres<<1)|1; //      ,      ( )
  
  TWCR = (1<<TWINT)|(1<<TWEN); //  ,   
  
  while(!(TWCR & (1<<TWINT))); //    

  if(podt==1) { //   
  
     TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN); //  ,   ,   
	 
     while(!(TWCR & (1<<TWINT))); //   
	 
     data = TWDR; //     
	 
  }
  
  else { //    
  
     TWCR = (1<<TWINT)|(1<<TWEN); //  ,   
	 
     while(!(TWCR & (1<<TWINT))); //   
	 
     data = TWDR; //     
  }
  
  //   ""
  
  TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN); //  ,   "",  
  
  return data; //   
  
}

int volatile GiX; // ,        

int volatile GiY; //   Y

int volatile GiZ; //   Z

int volatile AxX; // ,       

int volatile AxY; //   Y

int volatile AxZ; //   Z

void get_value_from_Axel (void) {

    TWI_send(0,0x3B,1); //   
  
    AxX=(TWI_read(0)<<8|TWI_read(0));
	
	AxX = AxX/10; //         
  
    TWI_send(0,0x3D,1); //   
  
    AxY=(TWI_read(0)<<8|TWI_read(0));
	
	AxY = AxY/10; //      Y   
  
    TWI_send(0,0x3F,1); //   
  
    AxZ=(TWI_read(0)<<8|TWI_read(0));
	
	AxZ = AxZ/10; //      Z   
  
    TWI_send(0,0x43,1); //   
  
    GiX=(TWI_read(0)<<8|TWI_read(0))/131;
  
    TWI_send(0,0x45,1); //   
  
    GiY=(TWI_read(0)<<8|TWI_read(0))/131;
  
    TWI_send(0,0x47,1); //   
  
    GiZ=(TWI_read(0)<<8|TWI_read(0))/131;

}

int kalibrovka_for_Axel [3]; //    (0  - X; 1-Y; 2-Z)

void Axel_kalibrovka (void) { //   

    //        

    TWI_send(0,0x3B,1); //   
  
    AxX=(TWI_read(0)<<8|TWI_read(0));
  
    TWI_send(0,0x3D,1); //   
  
    AxY=(TWI_read(0)<<8|TWI_read(0));
  
    TWI_send(0,0x3F,1); //   
  
    AxZ=(TWI_read(0)<<8|TWI_read(0));
	
	TWI_send(0,0x43,1); //   
  
    GiX=(TWI_read(0)<<8|TWI_read(0))/131;
  
    TWI_send(0,0x45,1); //   
  
    GiY=(TWI_read(0)<<8|TWI_read(0))/131;
  
    TWI_send(0,0x47,1); //   
  
    GiZ=(TWI_read(0)<<8|TWI_read(0))/131;

    kalibrovka_for_Axel[0] = AxX;//      
	
	kalibrovka_for_Axel[1] = AxY;//      Y
	
	kalibrovka_for_Axel[2] = AxZ;//      Z

}

void init_PWM (void) { //          

    DDRB |=(1<<servo_1)|(1<<servo_2)|(1<<sistem_LED); //       

    //     

    TCCR1A = (1<<COM1A1)|(0<<COM1A0)|(1<<COM1B1)|(0<<COM1B0)|(1<<WGM11)|(0<<WGM10); //  Fast PWM,      ,    ICR1

    TCCR1B = (0<<CS10)|(1<<CS11)|(0<<CS12)|(1<<WGM13)|(1<<WGM12); //  8

    ICR1 = 20000; //   

    //    2000  700 

    OCR1A = 1350; //      (1150 -    , 1550 -    )

    OCR1B = 1350;

}

void servo_controller (unsigned int data_servo_1, unsigned int data_servo_2) { // ,   

    if(data_servo_1<850) { OCR1A = 850; } else if (data_servo_1>1800) { OCR1A = 1800; } //      ,  
	
	else { OCR1A = data_servo_1;}
	
	if(data_servo_2<850) { OCR1B = 850; } else if (data_servo_2>1800) { OCR1B = 1800; } //      ,  
	
	else { OCR1B = data_servo_2; }
}

int main (void) {

    init_PWM(); //  
	
	TWI_init(); //  I2C 
	
	Axel_kalibrovka(); //  
	
	TWI_send(0b00000000,0x6B,0); //  0     6B -  
	
    TWI_send(0b00000000,0x1B,0);//     250 /
	
	_delay_ms(2000);
	
	int long sum_Y=0; 
	
	int long sum_X=0; 
	
	int value_return_Y [100]; //       Y  200 
	
	int value_return_X [100]; //       Y  200 
	
	unsigned char i=0; //    /
	
	int AxY_angel = 0; //       
	
	int AxX_angel = 0;
	
	PORTB |=(1<<sistem_LED); 
	
	while (1==1) { //         X  Y
		
	    if(i<50) {i=i+1;} else {i=0;} //       ,  ,  - 0
	
	    get_value_from_Axel(); //   
		
		value_return_Y [i] = AxY; //     
		
		value_return_X [i] = AxX; //     
		
		for(unsigned char k=0; k<50; k++) { //    
		
		    sum_Y = sum_Y + value_return_Y[k]; 
			
			sum_X = sum_X + value_return_X[k]; 
			
			} 
		
		AxY_angel=sum_Y/50; //       
		
		AxY_angel = AxY_angel*1.5; //    ,      
		
		AxX_angel=sum_X/50;
		
		AxX_angel = AxX_angel*1.5;
		
		sum_Y=0; //  
		
		sum_X=0;
		
		servo_controller(1350+AxY_angel-AxX_angel,1350-AxY_angel-AxX_angel); //     
	
	}
}